PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PMonitoredSockets Class Referenceabstract

This is a base class for UDP socket(s) that are monitored for interface changes. More...

`#include <psockbun.h>`

Inheritance diagram for PMonitoredSockets:
[legend]
Collaboration diagram for PMonitoredSockets:
[legend]

## Classes
struct | BundleParams
struct | SocketInfo

## Public Types
typedef PIPSocket::InterfaceEntry | InterfaceEntry

## Public Member Functions
virtual PBoolean | Open (WORD port)=0
| Open the socket(s) using the specified port. More...
PBoolean | IsOpen () const
| Indicate if the socket(s) are open and ready for reads/writes. More...
virtual PBoolean | Close ()=0
| Close all socket(s) More...
WORD | GetPort () const
| Return the local port number being used by the socket(s) More...
virtual PBoolean | GetAddress (const PString &iface, PIPSocket::Address &address, WORD &port, PBoolean usingNAT) const =0
| Get the local address for the given interface. More...
virtual void | WriteToBundle (BundleParams &param)=0
| Write to the remote address/port using the socket(s) available. More...
virtual void | ReadFromBundle (BundleParams &param)=0
| Read fram a remote address/port using the socket(s) available. More...
virtual PStringArray | GetInterfaces (bool includeLoopBack=false, const PIPSocket::Address &destination=PIPSocket::GetDefaultIpAny())
| Get an array of all current interface descriptors, possibly including the loopback (127.0.0.1) interface. More...
virtual bool | GetInterfaceInfo (const PString &iface, InterfaceEntry &info) const
| Return information about an active interface given the descriptor string. More...
Public Member Functions inherited from PSafeObject
| PSafeObject (PSafeObject *indirectLock=NULL)
| Create a thread safe object. More...
PBoolean | SafeReference ()
| Increment the reference count for object. More...
PBoolean | SafeDereference ()
| Decrement the reference count for object. More...
PBoolean | LockReadOnly () const
| Lock the object for Read Only access. More...
void | UnlockReadOnly () const
| Release the read only lock on an object. More...
PBoolean | LockReadWrite ()
| Lock the object for Read/Write access. More...
void | UnlockReadWrite ()
| Release the read/write lock on an object. More...
void | SafeRemove ()
| Set the removed flag. More...
PBoolean | SafelyCanBeDeleted () const
| Determine if the object can be safely deleted. More...
virtual bool | GarbageCollection ()
| Do any garbage collection that may be required by the object so that it may be finally deleted. More...
unsigned | GetSafeReferenceCount () const
| Get count of references to this object. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions
static PMonitoredSockets * | Create (const PString &iface, bool reuseAddr=falseP_NAT_PARAM(PNatMethod *natMethod=NULL))
| Create a new monitored socket instance based on the interface descriptor. More...

## Protected Member Functions
| PMonitoredSockets (bool reuseAddrP_NAT_PARAM(PNatMethod *natMethod))
bool | CreateSocket (SocketInfo &info, const PIPSocket::Address &binding)
bool | DestroySocket (SocketInfo &info)
bool | GetSocketAddress (const SocketInfo &info, PIPSocket::Address &address, WORD &port, bool usingNAT) const
void | ReadFromSocketList (PSocket::SelectList &readers, PUDPSocket *&socket, BundleParams &param)

## Protected Attributes
WORD | localPort
bool | reuseAddress
bool | opened
PUDPSocket | interfaceAddedSignal

## Detailed Description

This is a base class for UDP socket(s) that are monitored for interface changes.

Two derived classes are available, one that is permanently bound to an IP address and/or interface name. The second will dynamically open/close ports as interfaces are added and removed from the system.

## Member Typedef Documentation

typedef PIPSocket::InterfaceEntry PMonitoredSockets::InterfaceEntry

## Constructor & Destructor Documentation

PMonitoredSockets::PMonitoredSockets | ( | bool | reuseAddrP_NAT_PARAMPNatMethod *natMethod | ) |
| protected

Parameters

  reuseAddrP_NAT_PARAM | Flag for sharing socket/exclusve use NAT method to use to create sockets.

## Member Function Documentation

virtual PBoolean PMonitoredSockets::Close | ( |  | ) |
| pure virtual

Close all socket(s)

Implemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

static PMonitoredSockets* PMonitoredSockets::Create | ( | const PString & | iface,
|  | bool | reuseAddr = `falseP_NAT_PARAM(PNatMethod *natMethod=NULL)`
| ) |  |
| static

Create a new monitored socket instance based on the interface descriptor.

This will create a multiple or single socket derived class of PMonitoredSockets depending on the iface parameter.

If the iface parameter starts with a '' or "*%" then a bundle is created for all IP addresses for a specific interface.

If the iface has a non INADDR_ANY address value, with or without a iface qualifier, then only that IP address is listened to.

If the iface resolves to a specific INADDR_ANY or INADDR6_ANY, then only that version will be listened to, on all interfaces or

Finally if empty string or "*", than all IP versions and all interfaces are used.

Parameters

  iface | Interface name to create socket for
  reuseAddr | Re-use or exclusive port number NAT method

bool PMonitoredSockets::CreateSocket | ( | SocketInfo & | info,
|  | const PIPSocket::Address & | binding
| ) |  |
| protected

bool PMonitoredSockets::DestroySocket | ( | SocketInfo & | info | ) |
| protected

virtual PBoolean PMonitoredSockets::GetAddress | ( | const PString & | iface,
|  | PIPSocket::Address & | address,
|  | WORD & | port,
|  | PBoolean | usingNAT
| ) |  | const
| pure virtual

Get the local address for the given interface.

Parameters

  iface | Interface to get address for
  address | Address of interface
  port | Port listening on
  usingNAT | Require NAT address/port

Implemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

virtual bool PMonitoredSockets::GetInterfaceInfo | ( | const PString & | iface,
|  | InterfaceEntry & | info
| ) |  | const
| virtual

Return information about an active interface given the descriptor string.

Note that when searchin the descriptor may be a partial match e.g. "10.0.1.11" or "%eth0" may be used.

Parameters

  iface | Interface desciptor name
  info | Information on the interface

virtual PStringArray PMonitoredSockets::GetInterfaces | ( | bool | includeLoopBack = `false`,
|  | const PIPSocket::Address & | destination = `PIPSocket::GetDefaultIpAny()`
| ) |  |
| virtual

Get an array of all current interface descriptors, possibly including the loopback (127.0.0.1) interface.

Note the names are of the form ipname, eg "10.0.1.11%3Com 3C90x Ethernet Adapter" or "192.168.0.10%eth0". If destination is not 'any' and a filter is set, filters the interface list before returning it.

Parameters

  includeLoopBack | Flag for if loopback is to included in list
  destination | Optional destination for selecting specific interface

Reimplemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

WORD PMonitoredSockets::GetPort | ( |  | ) | const
| inline

Return the local port number being used by the socket(s)

References localPort.

bool PMonitoredSockets::GetSocketAddress | ( | const SocketInfo & | info,
|  | PIPSocket::Address & | address,
|  | WORD & | port,
|  | bool | usingNAT
| ) |  | const
| protected

PBoolean PMonitoredSockets::IsOpen | ( |  | ) | const
| inline

Indicate if the socket(s) are open and ready for reads/writes.

References opened.

virtual PBoolean PMonitoredSockets::Open | ( | WORD | port | ) |
| pure virtual

Open the socket(s) using the specified port.

If port is zero then a system allocated port is used. In this case and when multiple interfaces are supported, all sockets use the same dynamic port value.

Returns true if all sockets are opened.

Implemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

virtual void PMonitoredSockets::ReadFromBundle | ( | BundleParams & | param | ) |
| pure virtual

Read fram a remote address/port using the socket(s) available.

If the iface parameter is empty, then the first data received on any socket(s) is used, and the iface parameter is set to the name of that interface. Otherwise the iface parameter indicates the specific interface socket to read the data from.

Parameters

  param | Info on data to read

Implemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

void PMonitoredSockets::ReadFromSocketList | ( | PSocket::SelectList & | readers,
|  | PUDPSocket *& | socket,
|  | BundleParams & | param
| ) |  |
| protected

virtual void PMonitoredSockets::WriteToBundle | ( | BundleParams & | param | ) |
| pure virtual

Write to the remote address/port using the socket(s) available.

If the iface parameter is empty, then the data is written to all socket(s). Otherwise the iface parameter indicates the specific interface socket to write the data to.

Parameters

  param | Info on data to write

Implemented in PSingleMonitoredSocket, and PMonitoredSocketBundle.

## Member Data Documentation

PUDPSocket PMonitoredSockets::interfaceAddedSignal
| protected

WORD PMonitoredSockets::localPort
| protected

Referenced by GetPort().

bool PMonitoredSockets::opened
| protected

Referenced by IsOpen().

bool PMonitoredSockets::reuseAddress
| protected

The documentation for this class was generated from the following file:

- psockbun.h